package require -exact qsys 17.0

# create the system "jesd_tx"
proc do_create_jesd_tx {} {
	# create the system
	create_system jesd_tx
	set_project_property DEVICE {10AS057H3F34I2SG}
	set_project_property DEVICE_FAMILY {Arria 10}
	set_project_property HIDE_FROM_IP_CATALOG {true}
	set_use_testbench_naming_pattern 0 {}
	set_interconnect_requirement {$system} qsys_mm.clockCrossingAdapter {HANDSHAKE}
	set_interconnect_requirement {$system} qsys_mm.maxAdditionalLatency {0}

	# add the components
	add_instance jesd204_0 altera_jesd204 17.1
	set_instance_parameter_value jesd204_0 {ADJCNT} {0}
	set_instance_parameter_value jesd204_0 {ADJDIR} {0}
	set_instance_parameter_value jesd204_0 {BID} {0}
	set_instance_parameter_value jesd204_0 {CF} {0}
	set_instance_parameter_value jesd204_0 {CS} {0}
	set_instance_parameter_value jesd204_0 {DATA_PATH} {TX}
	set_instance_parameter_value jesd204_0 {DID} {0}
	set_instance_parameter_value jesd204_0 {DLB_TEST} {0}
	set_instance_parameter_value jesd204_0 {ECC_EN} {1}
	set_instance_parameter_value jesd204_0 {ED_3WIRE_SPI} {0}
	set_instance_parameter_value jesd204_0 {ED_DEV_KIT} {NONE}
	set_instance_parameter_value jesd204_0 {ED_FILESET_SIM} {1}
	set_instance_parameter_value jesd204_0 {ED_FILESET_SYNTH} {1}
	set_instance_parameter_value jesd204_0 {ED_HDL_FORMAT_SIM} {VERILOG}
	set_instance_parameter_value jesd204_0 {ED_HDL_FORMAT_SYNTH} {VERILOG}
	set_instance_parameter_value jesd204_0 {ED_SIM_PAT_TESTMODE} {PRBS_7}
	set_instance_parameter_value jesd204_0 {ED_SINGLE_REFCLK} {0}
	set_instance_parameter_value jesd204_0 {ED_TYPE} {DATAPATH}
	set_instance_parameter_value jesd204_0 {GUI_CFG_F} {2}
	set_instance_parameter_value jesd204_0 {GUI_EN_CFG_F} {0}
	set_instance_parameter_value jesd204_0 {HD} {0}
	set_instance_parameter_value jesd204_0 {JESDV} {1}
	set_instance_parameter_value jesd204_0 {K} {32}
	set_instance_parameter_value jesd204_0 {L} {4}
	set_instance_parameter_value jesd204_0 {LID0} {0}
	set_instance_parameter_value jesd204_0 {LID1} {1}
	set_instance_parameter_value jesd204_0 {LID2} {2}
	set_instance_parameter_value jesd204_0 {LID3} {3}
	set_instance_parameter_value jesd204_0 {LID4} {4}
	set_instance_parameter_value jesd204_0 {LID5} {5}
	set_instance_parameter_value jesd204_0 {LID6} {6}
	set_instance_parameter_value jesd204_0 {LID7} {7}
	set_instance_parameter_value jesd204_0 {M} {8}
	set_instance_parameter_value jesd204_0 {N} {16}
	set_instance_parameter_value jesd204_0 {N_PRIME} {16}
	set_instance_parameter_value jesd204_0 {OPTIMIZE} {0}
	set_instance_parameter_value jesd204_0 {PCS_CONFIG} {JESD_PCS_CFG1}
	set_instance_parameter_value jesd204_0 {PHADJ} {0}
	set_instance_parameter_value jesd204_0 {REFCLK_FREQ} {125.0}
	set_instance_parameter_value jesd204_0 {RES1} {0}
	set_instance_parameter_value jesd204_0 {RES2} {0}
	set_instance_parameter_value jesd204_0 {S} {1}
	set_instance_parameter_value jesd204_0 {SCR} {0}
	set_instance_parameter_value jesd204_0 {SUBCLASSV} {1}
	set_instance_parameter_value jesd204_0 {TERMINATE_RECONFIG_EN} {0}
	set_instance_parameter_value jesd204_0 {TEST_COMPONENTS_EN} {0}
	set_instance_parameter_value jesd204_0 {bitrev_en} {0}
	set_instance_parameter_value jesd204_0 {bonded_mode} {non_bonded}
	set_instance_parameter_value jesd204_0 {gui_analog_voltage} {1_0V}
	set_instance_parameter_value jesd204_0 {gui_user_crete_tile} {etile}
	set_instance_parameter_value jesd204_0 {lane_rate} {9830.4}
	set_instance_parameter_value jesd204_0 {pll_reconfig_enable} {0}
	set_instance_parameter_value jesd204_0 {pll_type} {CMU}
	set_instance_parameter_value jesd204_0 {rcfg_enable_split_interface} {0}
	set_instance_parameter_value jesd204_0 {rcfg_jtag_enable} {0}
	set_instance_parameter_value jesd204_0 {rcfg_shared} {0}
	set_instance_parameter_value jesd204_0 {sdc_constraint} {1.0}
	set_instance_parameter_value jesd204_0 {set_capability_reg_enable} {0}
	set_instance_parameter_value jesd204_0 {set_csr_soft_logic_enable} {0}
	set_instance_parameter_value jesd204_0 {set_prbs_soft_logic_enable} {0}
	set_instance_parameter_value jesd204_0 {set_user_identifier} {0}
	set_instance_parameter_value jesd204_0 {wrapper_opt} {base_phy}
	set_instance_property jesd204_0 AUTO_EXPORT true

	# add the exports
	set_interface_property csr_cf EXPORT_OF jesd204_0.csr_cf
	set_interface_port_property csr_cf csr_cf_export NAME csr_cf
	set_interface_property csr_cs EXPORT_OF jesd204_0.csr_cs
	set_interface_port_property csr_cs csr_cs_export NAME csr_cs
	set_interface_property csr_f EXPORT_OF jesd204_0.csr_f
	set_interface_port_property csr_f csr_f_export NAME csr_f
	set_interface_property csr_hd EXPORT_OF jesd204_0.csr_hd
	set_interface_port_property csr_hd csr_hd_export NAME csr_hd
	set_interface_property csr_k EXPORT_OF jesd204_0.csr_k
	set_interface_port_property csr_k csr_k_export NAME csr_k
	set_interface_property csr_l EXPORT_OF jesd204_0.csr_l
	set_interface_port_property csr_l csr_l_export NAME csr_l
	set_interface_property csr_lane_powerdown EXPORT_OF jesd204_0.csr_lane_powerdown
	set_interface_port_property csr_lane_powerdown csr_lane_powerdown_export NAME csr_lane_powerdown
	set_interface_property csr_m EXPORT_OF jesd204_0.csr_m
	set_interface_port_property csr_m csr_m_export NAME csr_m
	set_interface_property csr_n EXPORT_OF jesd204_0.csr_n
	set_interface_port_property csr_n csr_n_export NAME csr_n
	set_interface_property csr_np EXPORT_OF jesd204_0.csr_np
	set_interface_port_property csr_np csr_np_export NAME csr_np
	set_interface_property csr_s EXPORT_OF jesd204_0.csr_s
	set_interface_port_property csr_s csr_s_export NAME csr_s
	set_interface_property csr_tx_testmode EXPORT_OF jesd204_0.csr_tx_testmode
	set_interface_port_property csr_tx_testmode csr_tx_testmode_export NAME csr_tx_testmode
	set_interface_property csr_tx_testpattern_a EXPORT_OF jesd204_0.csr_tx_testpattern_a
	set_interface_port_property csr_tx_testpattern_a csr_tx_testpattern_a_export NAME csr_tx_testpattern_a
	set_interface_property csr_tx_testpattern_b EXPORT_OF jesd204_0.csr_tx_testpattern_b
	set_interface_port_property csr_tx_testpattern_b csr_tx_testpattern_b_export NAME csr_tx_testpattern_b
	set_interface_property csr_tx_testpattern_c EXPORT_OF jesd204_0.csr_tx_testpattern_c
	set_interface_port_property csr_tx_testpattern_c csr_tx_testpattern_c_export NAME csr_tx_testpattern_c
	set_interface_property csr_tx_testpattern_d EXPORT_OF jesd204_0.csr_tx_testpattern_d
	set_interface_port_property csr_tx_testpattern_d csr_tx_testpattern_d_export NAME csr_tx_testpattern_d
	set_interface_property dev_sync_n EXPORT_OF jesd204_0.dev_sync_n
	set_interface_port_property dev_sync_n dev_sync_n_export NAME dev_sync_n
	set_interface_property jesd204_tx_avs EXPORT_OF jesd204_0.jesd204_tx_avs
	set_interface_property jesd204_tx_avs_clk EXPORT_OF jesd204_0.jesd204_tx_avs_clk
	set_interface_port_property jesd204_tx_avs_clk jesd204_tx_avs_clk_clk NAME jesd204_tx_avs_clk
	set_interface_property jesd204_tx_avs_rst_n EXPORT_OF jesd204_0.jesd204_tx_avs_rst_n
	set_interface_port_property jesd204_tx_avs_rst_n jesd204_tx_avs_rst_n_reset_n NAME jesd204_tx_avs_rst_n
	set_interface_property jesd204_tx_dlb_data EXPORT_OF jesd204_0.jesd204_tx_dlb_data
	set_interface_port_property jesd204_tx_dlb_data jesd204_tx_dlb_data_export NAME jesd204_tx_dlb_data
	set_interface_property jesd204_tx_dlb_kchar_data EXPORT_OF jesd204_0.jesd204_tx_dlb_kchar_data
	set_interface_port_property jesd204_tx_dlb_kchar_data jesd204_tx_dlb_kchar_data_export NAME jesd204_tx_dlb_kchar_data
	set_interface_property jesd204_tx_frame_error EXPORT_OF jesd204_0.jesd204_tx_frame_error
	set_interface_port_property jesd204_tx_frame_error jesd204_tx_frame_error_export NAME jesd204_tx_frame_error
	set_interface_property jesd204_tx_frame_ready EXPORT_OF jesd204_0.jesd204_tx_frame_ready
	set_interface_port_property jesd204_tx_frame_ready jesd204_tx_frame_ready_export NAME jesd204_tx_frame_ready
	set_interface_property jesd204_tx_int EXPORT_OF jesd204_0.jesd204_tx_int
	set_interface_port_property jesd204_tx_int jesd204_tx_int_irq NAME jesd204_tx_int
	set_interface_property jesd204_tx_link EXPORT_OF jesd204_0.jesd204_tx_link
	set_interface_property mdev_sync_n EXPORT_OF jesd204_0.mdev_sync_n
	set_interface_port_property mdev_sync_n mdev_sync_n_export NAME mdev_sync_n
	set_interface_property pll_locked EXPORT_OF jesd204_0.pll_locked
	set_interface_port_property pll_locked pll_locked_pll_locked NAME pll_locked
	set_interface_property somf EXPORT_OF jesd204_0.somf
	set_interface_port_property somf somf_export NAME somf
	set_interface_property sync_n EXPORT_OF jesd204_0.sync_n
	set_interface_port_property sync_n sync_n_export NAME sync_n
	set_interface_property sysref EXPORT_OF jesd204_0.sysref
	set_interface_port_property sysref sysref_export NAME sysref
	set_interface_property tx_analogreset EXPORT_OF jesd204_0.tx_analogreset
	set_interface_port_property tx_analogreset tx_analogreset_tx_analogreset NAME tx_analogreset
	set_interface_property tx_cal_busy EXPORT_OF jesd204_0.tx_cal_busy
	set_interface_port_property tx_cal_busy tx_cal_busy_tx_cal_busy NAME tx_cal_busy
	set_interface_property tx_digitalreset EXPORT_OF jesd204_0.tx_digitalreset
	set_interface_port_property tx_digitalreset tx_digitalreset_tx_digitalreset NAME tx_digitalreset
	set_interface_property tx_serial_clk0_ch0 EXPORT_OF jesd204_0.tx_serial_clk0_ch0
	set_interface_port_property tx_serial_clk0_ch0 tx_serial_clk0_ch0_clk NAME tx_serial_clk0_ch0
	set_interface_property tx_serial_clk0_ch1 EXPORT_OF jesd204_0.tx_serial_clk0_ch1
	set_interface_port_property tx_serial_clk0_ch1 tx_serial_clk0_ch1_clk NAME tx_serial_clk0_ch1
	set_interface_property tx_serial_clk0_ch2 EXPORT_OF jesd204_0.tx_serial_clk0_ch2
	set_interface_port_property tx_serial_clk0_ch2 tx_serial_clk0_ch2_clk NAME tx_serial_clk0_ch2
	set_interface_property tx_serial_clk0_ch3 EXPORT_OF jesd204_0.tx_serial_clk0_ch3
	set_interface_port_property tx_serial_clk0_ch3 tx_serial_clk0_ch3_clk NAME tx_serial_clk0_ch3
	set_interface_property tx_serial_data EXPORT_OF jesd204_0.tx_serial_data
	set_interface_port_property tx_serial_data tx_serial_data_tx_serial_data NAME tx_serial_data
	set_interface_property txlink_clk EXPORT_OF jesd204_0.txlink_clk
	set_interface_port_property txlink_clk txlink_clk_clk NAME txlink_clk
	set_interface_property txlink_rst_n EXPORT_OF jesd204_0.txlink_rst_n
	set_interface_property txphy_clk EXPORT_OF jesd204_0.txphy_clk
	set_interface_port_property txphy_clk txphy_clk_export NAME txphy_clk

	# set the the module properties
	set_module_property BONUS_DATA {<?xml version="1.0" encoding="UTF-8"?>
<bonusData>
 <element __value="$system">
  <datum __value="_originalDeviceFamily" value="Arria 10" type="String" />
 </element>
 <element __value="jesd204_0">
  <datum __value="_sortIndex" value="0" type="int" />
 </element>
</bonusData>
}
	set_module_property FILE {jesd_tx.ip}
	set_module_property GENERATION_ID {0x00000000}
	set_module_property NAME {jesd_tx}

	# save the system
	sync_sysinfo_parameters
	save_system jesd_tx.ip
}

# create all the systems, from bottom up
do_create_jesd_tx
